/*
	Author		: Michael Janea
	Version		: 1.1
	Author URL	: www.michaeljanea.com
*/

(function($){
	
	//define plugin
    $.fn.mjTab = function(options){
        
		//defaults
		var defaults = {
			duration: 400
		};
		
		//variables
		var playing = false;
		
		//extends
		var settings = $.extend({}, defaults, options);
		
		//function
		return this.each(function(){
			
			//on tab click
			$(this).find('.mj_tab_items').children().on('click', function(){
				
				//not playing
				if(!playing && !$(this).hasClass('active')){
					
					//playing
					playing = true;
				
					//element var
					var el = $(this);
					
					//add active class and remove active class from its siblings
					$(this).addClass('active').siblings().removeClass('active');
					
					//show current active
					$(this).parent().siblings('.mj_tab_contents').children('.active').stop(true, true).fadeOut(settings.duration, function(){

						//remove active and inline css generated by jquery and show next content
						$(this).removeClass('active').removeAttr('style').parent().children(':nth-child(' + ($(el).index() + 1) + ')').stop(true, true).fadeIn(settings.duration, function(){
							
							//add active class and remove inline css generated by jquery
							$(this).addClass('active').removeAttr('style');
							
							//not playing
							playing = false;
							
						});
						
					});
					
				}
				
			});
			
		});
		
    };
	
})(jQuery);